#!/usr/bin/perl
# type: perl jitter-flow-F-at-node.pl <tracefile> <flowID> <node> <period>

$infile=$ARGV[0];
$flowid=$ARGV[1];
$tonode=$ARGV[2];
$period=$ARGV[3];

# we print the jitter of packets sequence belonging to the same flow 
# arriving at a given node
# we use the method reported in RFC 3550 assuming periodic transmission
# D(i,j) = |(Ri - Rj)-(Si - Sj)| = |(Ri - Rj)-P|

$npck = 0;
$sum = 0;
$Rj = 0;
$jitter = 0;

open (DATA, "<$infile") 
   || die "Can't open $infile $!";

while (<DATA>) 
{ 
  @x = split(' ');
  if($x[7] eq $flowid)
  {
    if($x[0] eq 'r')
    {
      if($x[3] eq $tonode)
      {
        print STDOUT "$x[1]\n";

	if($Rj eq 0)
	{
	  $Rj = $x[1];
	}
	else
	{
          $npck = $npck + 1;
	  $sum = $sum + abs($x[1]-$Rj-$period);
	  $Rj = $x[1];
	}
      }
    }
  }
}

$jitter=$sum/$npck;
print STDOUT "Jitter $jitter sec.\n";

close DATA;
exit(0);

