#!/usr/bin/perl
# type: perl throughput.pl <tracefile> <flow> <node> <granularity>

$infile=$ARGV[0];
$flowid=$ARGV[1];
$tonode=$ARGV[2];
$granularity=$ARGV[3];

# we compute how many bytes of a given flow arrived at a given node 
# during the time interval specified by granularity parameter in seconds

$sum=0;
$clock=0;

open (DATA, "<$infile") 
   || die "Can't open $infile $!";

print STDOUT "Time \t Throughput (Mb/s)\n";

while (<DATA>) 
{ 
  @x = split(' ');
  if($x[1]-$clock <= $granularity)
  {
    if($x[0] eq 'r')
    {
      if($x[3] eq $tonode)
      {
        if($x[7] eq $flowid)
        {
          $sum=$sum+$x[5];
        }
      }
    }
  }
  else
  {
    $throughput=($sum*8)/($granularity*1000000);
    print STDOUT "$x[1] \t $throughput Mb/s\n";
    $clock=$clock+$granularity;
    $sum=0;
  }
}
$throughput=($sum*8)/($granularity*1000000);
print STDOUT "$x[1] \t $throughput Mb/s\n";
$clock=$clock+$granularity;
$sum=0;

close DATA;
exit(0);

